package com.ruoyi.busi.mapper;

import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.busi.domain.BusiNoticeSign;
import com.ruoyi.busi.query.AppNoticeQuery;
import org.apache.ibatis.annotations.Param;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;

/**
 * 通告报名Mapper接口
 *
 * @author 朱春云
 * @date 2025-03-17
 */
@Mapper
public interface BusiNoticeSignMapper extends BaseMapper<BusiNoticeSign>
{
    IPage<BusiNoticeSign> queryListPage(@Param("entity") BusiNoticeSign entity, Page<BusiNoticeSign> page);

    IPage<BusiNoticeSign> reportList( Page<BusiNoticeSign> page,@Param("entity") AppNoticeQuery entity);



    /**
     * 查某些公告的报名数量
     * @author vinjor-M
     * @date 16:50 2025/3/25
     * @param idList 公告id
     * @return java.util.List<java.util.Map<java.lang.String,java.lang.Object>>
    **/
    List<Map<String,Object>> selectReportNumByIdList(@Param("list")List<String> idList);
}
